/*  libbadpenguin -- generic library for Bad Penguin development
 *
 *  Copyright (C) 1996 Antonio Gallo
 *  agx@linux.it
 *  Rewritten by Loren Lang, 9-26-01
 *  lorenl@tallye.com
 *  
 *  Newer versions should be on www.badpenguin.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <stdio.h>
#include "badpenguin-ansi.h"

void ansi_move_home() {
	printf("\033[H");
}

void ansi_move_lowerleft() {
	printf("\033[1;25r\033[25;1H");
}

void ansi_move_up(int i) {
	printf("\033[%iA\007",i);
}

void ansi_move_down(int i) {
	printf("\033[%iB\007", i);
}

void ansi_move_right(int i) {
	printf("\033[%iC\007", i);
}

void ansi_move_left(int i) {
	printf("\033[%id\007", i);
}

void ansi_push_cursor() {
	printf("\033[s\007");
}

void ansi_pop_cursor() {
	printf("\033[u\007");
}


void ansi_clreol() {
	printf("\033[K\007");
}

void ansi_clreos() {
	printf("\033[J\007");
}

void printBackTitle(char *s) {
	printf("\033[0;0H\007");
	printf(FG_CYAN BG_BLUE "\007");
	printf("%s\n", s);
	printf("-------------------------------------------------------------------------------\n");
}

