/*  libbadpenguin -- generic library for Bad Penguin development
 *
 *  Copyright (C) 1996 Antonio Gallo
 *  agx@linux.it
 *  
 *  Newer versions should be on www.badpenguin.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <config.h>

#include <sys/stat.h>
#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <libintl.h>
#define _(a)	dgettext(PACKAGE, a)

#include "badpenguin-ansi.h"


// Remove everything from a specified path ... take care
int deltree(char *path) {
  struct stat lpststat;
  struct dirent *lpstdirent = NULL;
  DIR *lpstdir = NULL;
  int oldval = 0;
  int retval = 0;
  char tempdir[256];
    
  // Return if not exists
  if ( 0 != lstat(path, &lpststat)) return 0;
  // Delete everything into a subdirectory
  if (S_ISDIR (lpststat.st_mode)) {
    lpstdir = opendir(path);
    // If dir is not empty then remove it
    if (lpstdir != NULL) {
      lpstdirent = readdir (lpstdir);
      while (lpstdirent != NULL) {
        if (
	  ( strlen(lpstdirent->d_name) >2 ) ||
	  (
	    ( 0 != strcmp(lpstdirent->d_name, ".")) &&
	    ( 0 != strcmp(lpstdirent->d_name, ".."))
	  )
	) {
	  snprintf(tempdir, 256, "%s/%s", path, lpstdirent->d_name);
	  retval += deltree(tempdir);
	}
	lpstdirent = readdir (lpstdir);
       }
       closedir (lpstdir);
     }
     // Remove dir
     oldval = retval;
     retval += rmdir(path);
     if ( retval - oldval != 0 ) {
       printWARNING(_("deltree: error while removing directory %s\n"), path); 
       normal_color();
     }
     // Return the sum of the error codes
     return retval;
  } else {
    retval = unlink (path);
    if (retval!=0) { 
      printWARNING(_("deltree: error while deleting file %s\n"), path); 
       normal_color();      
    }
    return retval;
  }
}

